<template>
  <div>
    <base-dialog :show="!!error" title="Wystąpił błąd" @close="handleError">
      <p>{{ error }}</p>
    </base-dialog>
    <base-card v-if="isLoading">
      <base-spinner></base-spinner>
    </base-card>
    <base-card v-else>
      <form @submit.prevent="submitForm" class="formStyling">
        <div class="form-control" :class="{ invalid: !email.isValid }">
          <label for="email">Email</label>
          <input
            type="email"
            id="email"
            v-model.trim="email.val"
            @blur="clearValidity('email')"
          />
          <p v-if="!email.isValid">Wprowadź prawidłowy adres email.</p>
        </div>
        <div class="form-control" :class="{ invalid: !password.isValid }">
          <label for="password">Password</label>
          <input
            type="password"
            id="password"
            v-model.trim="password.val"
            @blur="clearValidity('password')"
          />
          <p v-if="!password.isValid">
            Hasło musi zawierać co najmniej 6 znaków.
          </p>
        </div>
        <div v-if="mode === 'signup'" class="form-control">
          <label for="role">Wybierz rolę </label>
          <select id="role" name="role" v-model="role">
            <option value="ROLE_STUDENT">Student</option>
            <option value="ROLE_LECTURER">Wykładowca</option>
          </select>
        </div>
        <base-button>{{ submitButtonCaption }}</base-button>
        <base-button type="button" mode="flat" @click="switchAuthMode"
          >{{ switchModeButtonCaption }}
        </base-button>
      </form>
    </base-card>
  </div>
</template>

<script setup>
import { ref, computed } from "vue";
import { useRouter } from "vue-router";
import { useStore } from "vuex";

const router = useRouter();
const store = useStore();

const email = ref({
  val: "",
  isValid: true,
});
const password = ref({
  val: "",
  isValid: true,
});
const role = ref("ROLE_STUDENT");
const formIsValid = ref(true);
const mode = ref("login");
const isLoading = ref(false);
const error = ref(null);

const submitButtonCaption = computed(function () {
  return mode.value === "login" ? "Login" : "Signup";
});
const switchModeButtonCaption = computed(function () {
  return mode.value === "login" ? "Signup instead" : "Login instead";
});

function validateForm() {
  formIsValid.value = true;
  if (email.value.val === "" || !email.value.val.includes("@")) {
    email.value.isValid = false;
    formIsValid.value = false;
  }
  if (password.value.val.length < 6) {
    password.value.isValid = false;
    formIsValid.value = false;
  }
}

async function submitForm() {
  validateForm();

  if (!formIsValid.value) {
    return;
  }

  isLoading.value = true;

  const actionPayload = {
    email: email.value.val,
    password: password.value.val,
    role: role.value,
  };

  try {
    if (mode.value === "login") {
      await store.dispatch("login", actionPayload);
    } else {
      await store.dispatch("signup", actionPayload);
    }
    await router.replace("/");
  } catch (e) {
    error.value = e.message || "Spróbuj później.";
  }

  isLoading.value = false;
}

function switchAuthMode() {
  mode.value === "login" ? (mode.value = "signup") : (mode.value = "login");
}

function handleError() {
  error.value = null;
}

function clearValidity(input) {
  this[input].isValid = true;
}
</script>
